FasterLoot = LibStub('AceAddon-3.0'):NewAddon('FasterLoot', 'AceConsole-3.0', 'AceEvent-3.0')
local F = FasterLoot

F.frame = CreateFrame('Frame')
F.blacklist = {
	['TradeSkillMaster_Destroying'] = 'TSMDestroyingFrame',
	['Easy_Obliterate'] = 'ObliterumForgeFrame'
}
F.lootready = false
F.lootdelay = 0.025
F.lootcount = 0

F:RegisterEvent('LOOT_READY', function(event, ...)
	if F.lootready then
		return
	end
	
	for k, v in pairs(F.blacklist) do
		if IsAddOnLoaded(k) and _G[v]:IsVisible() then
			return
		end
	end
	
	F.lootready = true
	F.lootcount = 80
end)

function F:OnInitialize()
	F.frame:SetScript('OnUpdate', function(self, elapsed)
		if GetCVar("autoLootDefault") ~= "1" then
			return
		end
		
		if not F.lootready or F.lootcount == 0 then
			F.lootcount = 0
			F.lootready = false
			return
		end
		
		if not self.elapsed then
			self.elapsed = 0
		end
		self.elapsed = self.elapsed + elapsed
		
		if self.elapsed < F.lootdelay then
			return
		end
		
		F.lootcount = F.lootcount - 1
		for i = GetNumLootItems(), 1, -1 do
			LootSlot(i)
		end
		
		if GetNumLootItems() == 0 then
			F.lootready = false
			F.lootcount = 0
		end
	end)
end